// Test program for 32X RLE framebuffer mode
// Mic, 2009

#include "32x.h"

extern char maruko,maruko_end;
extern char palette,palette_end;
extern char maruko_ltb;
int numColors;
int imgSize;

void slave()
{
	while (1) {}
}


int main()
{
	uint16 currentFB=0;
	vu16 *frameBuffer16 = &MARS_FRAMEBUFFER;
	vu16 *cram16 = &MARS_CRAM;
	vu16 *img16 = (vu16*)&maruko;
	vu16 *pal16 = (vu16*)&palette;
	vu16 *ltbl16 = (vu16*)&maruko_ltb;

	int i;

	// Wait for the SH2 to gain access to the VDP
	while ((MARS_SYS_INTMSK & MARS_SH2_ACCESS_VDP) == 0) {}

	// Set 8-bit paletted run-length encoded mode, 224 lines
	MARS_VDP_DISPMODE = MARS_224_LINES | MARS_VDP_MODE_RLE;

	numColors = ((&palette_end)-(&palette)) / 2;
	for (i = 0; i < numColors; i++)
	{
		cram16[i] = pal16[i] & 0x7FFF;
	}

	MARS_VDP_FBCTL = currentFB;

	imgSize = ((&maruko_end)-(&maruko)) / 2;

    for(;;)
    {
		MARS_VDP_FBCTL = currentFB ^ 1;
		while ((MARS_VDP_FBCTL & MARS_VDP_FS) == currentFB) {}
		currentFB ^= 1;

		for (i = 0; i < imgSize; i++)
		{
			frameBuffer16[i + 0x100] = img16[i];
		}

		// Load the linetable data generated by sixpack
		for (i = 0; i < 224; i++)
		{
			frameBuffer16[i] = ltbl16[i] + 0x100;
		}


     }

	return 0;
}
